



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【原】Spark不同运行模式下资源分配源码解读</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【原】Spark不同运行模式下资源分配源码解读</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 11:39:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p><strong>版权声明：本文为原创文章，未经允许不得转载。</strong><br />
复习内容：<br />
Spark中Task的提交源码解读 <a href="http://www.cnblogs.com/yourarebest/p/5423906.html" rel="external nofollow noreferrer">http://www.cnblogs.com/yourarebest/p/5423906.html</a></p></blockquote>
<p>SchedulerBackend是一个trait，它配合TaskSchedulerImpl共同完成Task调度、执行、资源的分配等。它的子类如下所示，不同的子类对应的不同Spark不同的资源分配调度。详见图1。<br />
<img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/438458/201604/438458-20160423093540866-1892680765.png" /><br />
图1 SchedulerBackend子类继承图</p>
<p>Spark中不同（集群）模式进行资源的分配是通过调用backend.reviveOffers()方法来给Task分配资源的，其调度子类与其负责的运行模式如下所示：<br />
<strong>LocalBackend</strong><br />
（1）本地单线程运行模式，master形如local<br />
（2）本地多线程运行模式,匹配local[N]和Local[*]，<br />
（3）匹配local[*, M]和local[N, M]<br />
<strong>SparkDeploySchedulerBackend</strong><br />
（4）匹配Spark Standalone运行模式<br />
（5）匹配local-cluster运行模式即伪分布模式<br />
<strong>YarnClusterSchedulerBackend</strong><br />
（6）&quot;yarn-standalone&quot;或&quot;yarn-cluster&quot;运行模式，<br />
（7）yarn-client运行模式<br />
<strong>CoarseMesosSchedulerBackend（粗粒度）和MesosSchedulerBackend（细粒度）</strong><br />
（8）匹配Mesos运行模式，mesos有粗粒度和细粒度两种调度模式。<br />
补充：细粒度模式目前仅支持Mesos。<br />
<strong>粗粒度调度模式中</strong>，每个Executor在获得系统资源后，就长期拥有，直到应用程序退出才释放资源。优点：减少了资源调度的时间开销，缺点：所分配的资源被某个应用长期占有，造成资源的浪费。<br />
<strong>细粒度调度模式中</strong>，资源是根据任务的需求动态调度的，任务完成后就还给Mesos，所以不存在资源浪费的问题，但调度延迟较大。</p>
<h1>1.LocalBackend</h1>
<p>调用远程的一个引用申请资源，该远程引用已在start方法中赋值</p>
<p>override def reviveOffers() {<br />
localEndpoint.send(ReviveOffers)<br />
}</p>
<p>LocalBackend收到远程的ReviveOffers消息在receive方法中进行消息的匹配，进行资源的分配，如下所示：</p>
<p>override def receive: PartialFunction[Any, Unit] = {<br />
case ReviveOffers =&gt;<br />
reviveOffers()详见（1）<br />
case StatusUpdate(taskId, state, serializedData) =&gt;<br />
scheduler.statusUpdate(taskId, state, serializedData)<br />
if (TaskState.isFinished(state)) {<br />
freeCores += scheduler.CPUS_PER_TASK<br />
reviveOffers()<br />
}<br />
case KillTask(taskId, interruptThread) =&gt;<br />
executor.killTask(taskId, interruptThread)<br />
}</p>
<p>（1）方法 reviveOffers()如下所示：</p>
<p>def reviveOffers() {<br />
val offers = Seq(new WorkerOffer(localExecutorId, localExecutorHostname, freeCores))<br />
for (task &lt;- scheduler.resourceOffers(offers).flatten) {<br />
freeCores -= scheduler.CPUS_PER_TASK<br />
//在executor上创建Task<br />
executor.launchTask(executorBackend, taskId = task.taskId, attemptNumber = task.attemptNumber,<br />
task.name, task.serializedTask)<br />
}<br />
}</p>
<h1>2.SparkDeploySchedulerBackend</h1>
<p>由图1 SchedulerBackend子类继承我们知道SparkDeploySchedulerBackend是类CoarseGrainedSchedulerBackend的子类，属于粗粒度调度模式，类CoarseGrainedSchedulerBackend的子类的调度都是通过它的reviveOffers方法来完成的，因为都属于粗粒度调度模式。<br />
远程引用申请资源</p>
<p>override def reviveOffers() {<br />
driverEndpoint.send(ReviveOffers)<br />
}</p>
<p>同样在receive方法匹配ReviveOffers 消息，调用方法 makeOffers()</p>
<p>override def receive: PartialFunction[Any, Unit] = {<br />
case ReviveOffers =&gt;<br />
makeOffers()详见（1）</p>
<p>（1）makeOffers()方法如下所示</p>
<p>private def makeOffers() {<br />
//过滤掉正在kill的executor<br />
val activeExecutors = executorDataMap.filterKeys(!executorsPendingToRemove.contains(_))<br />
val workOffers = activeExecutors.map { case (id, executorData) =&gt;<br />
new WorkerOffer(id, executorData.executorHost, executorData.freeCores)<br />
}.toSeq<br />
//创建tasks<br />
launchTasks(scheduler.resourceOffers(workOffers))详见（2）（3）<br />
}</p>
<p>（2）scheduler.resourceOffers(workOffers)方法如下所示,TaskScheduleImpl调用提供slaves上的资源。我们通过按照激活的task set的优先级。我们以循环的方式将tasks均匀分配到节点上</p>
<p>def resourceOffers(offers: Seq[WorkerOffer]): Seq[Seq[TaskDescription]] = synchronized {<br />
var newExecAvail = false<br />
//对于每一个Executor进行如下操作,主要进行slave的hostname与executor的映射<br />
for (o &lt;- offers) {<br />
executorIdToHost(o.executorId) = o.host<br />
activeExecutorIds += o.executorId<br />
if (!executorsByHost.contains(o.host)) {<br />
executorsByHost(o.host) = new HashSet<a href="" rel="external nofollow noreferrer">String</a><br />
executorAdded(o.executorId, o.host)<br />
newExecAvail = true<br />
}<br />
for (rack &lt;- getRackForHost(o.host)) {<br />
hostsByRack.getOrElseUpdate(rack, new HashSet<a href="" rel="external nofollow noreferrer">String</a>) += o.host<br />
}<br />
}<br />
//随机shuffle操作避免将tasks分配到同样的一批workers上<br />
val shuffledOffers = Random.shuffle(offers)<br />
// Build a list of tasks to assign to each worker.<br />
val tasks = shuffledOffers.map(o =&gt; new ArrayBuffer<a href="o.cores" rel="external nofollow noreferrer">TaskDescription</a>)<br />
val availableCpus = shuffledOffers.map(o =&gt; o.cores).toArray<br />
//根据调度策略获取TaskSetManage的调度顺序<br />
val sortedTaskSets = rootPool.getSortedTaskSetQueue<br />
for (taskSet &lt;- sortedTaskSets) {<br />
logDebug(&quot;parentName: %s, name: %s, runningTasks: %s&quot;.format(<br />
taskSet.parent.name, taskSet.name, taskSet.runningTasks))<br />
if (newExecAvail) {<br />
taskSet.executorAdded()<br />
}<br />
}<br />
//根据调度策略依次得到TaskSet，<br />
//在节点上尝试5种Locality，PROCESS_LOCAL, NODE_LOCAL, NO_PREF, RACK_LOCAL, ANY<br />
//以最快的速度执行task<br />
var launchedTask = false<br />
for (taskSet &lt;- sortedTaskSets; maxLocality &lt;- taskSet.myLocalityLevels) {<br />
do {<br />
launchedTask = resourceOfferSingleTaskSet(<br />
taskSet, maxLocality, shuffledOffers, availableCpus, tasks)<br />
} while (launchedTask)<br />
}<br />
if (tasks.size &gt; 0) {<br />
hasLaunchedTask = true<br />
}<br />
return tasks<br />
}</p>
<p>（3）launchTasks方法如下所示</p>
<p>private def launchTasks(tasks: Seq[Seq[TaskDescription]]) {<br />
for (task &lt;- tasks.flatten) {<br />
//序列化task<br />
val serializedTask = ser.serialize(task)<br />
if (serializedTask.limit &gt;= akkaFrameSize - AkkaUtils.reservedSizeBytes) {<br />
scheduler.taskIdToTaskSetManager.get(task.taskId).foreach { taskSetMgr =&gt;<br />
try {<br />
var msg = &quot;Serialized task %s:%d was %d bytes, which exceeds max allowed: &quot; +<br />
&quot;spark.akka.frameSize (%d bytes) - reserved (%d bytes). Consider increasing &quot; +<br />
&quot;spark.akka.frameSize or using broadcast variables for large values.&quot;<br />
msg = msg.format(task.taskId, task.index, serializedTask.limit, akkaFrameSize,<br />
AkkaUtils.reservedSizeBytes)<br />
taskSetMgr.abort(msg)<br />
} catch {<br />
case e: Exception =&gt; logError(&quot;Exception in error callback&quot;, e)<br />
}<br />
}<br />
}<br />
else {<br />
val executorData = executorDataMap(task.executorId)<br />
executorData.freeCores -= scheduler.CPUS_PER_TASK<br />
//类CoarseGrainedExecutorBackend在Executor上反序列化task并完成task的创建<br />
executorData.executorEndpoint.send(LaunchTask(new SerializableBuffer(serializedTask)))<br />
}<br />
}<br />
}</p>
<h1>3.MesosSchedulerBackend</h1>
<p>Mesos细粒度调度模式时通过Mesos中的类MesosSchedulerDriver来完成调度，有兴趣的读者可以看一下。这里就不介绍了</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e33xq1.html">Threadlocal使用Case</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy1megq.html">Where product development should start</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7y2e1q.html">关于oracle的rowid</a>
		</li>
						<li><a href="https://www.batexi.com/a/r932r3zq.html">ibatis批量操作补充</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ged5q.html">MVC4 数据验证、特性、自动属性总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wme0oq.html">RPG JS&colon;免费开源的跨平台RPG游戏引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrnm79.html">Asp&period;Net Core- 配置组件详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0er79.html">Web端的Tab控件在切换Tab时Load数据出错的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp0x3j9.html">SQL 多个表之间联合查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy16rzdq.html">python爬虫-抓取acg12动漫壁纸排行设置为桌面壁纸</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj4o1l8.html">C&num;导出&period;csv格式的excel表</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1oeodq.html">Chris Richardson微服务翻译：微服务介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/950od2v8.html">php密码对称encrypt加密</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvwj6l8.html">memcached解压报错gzip&colon; stdin&colon; not in gzip format tar&colon; Child returned status 1 tar&colon; Error is not recoverable&colon; exiting now的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv7mw38.html">APP-6-百度地图导航</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2oeopq.html">C&plus;&plus;：实现类似MFC的IsKindOf功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvvj3dq.html">Bind-DLZ with MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwoky3k9.html">基于usb4java实现的java下的usb通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/9je0j048.html">LeetCode OJ：Palindrome Partitioning（回文排列）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q155n009.html">Picture POJ - 1177 （线段树-扫描线）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95xn6008.html">Spring MVC常用的注解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnxgy6q.html">Load a script file in sencha&comma; supports both asynchronous and synchronous approaches</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmxyzk9.html">iOS实现地图半翻页效果--老代码备用参考</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0gj6wq.html">sjtu1333 函数时代</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z2z449.html">Ubuntu14&period;04建立WiFi热点</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdelpm09.html">codeforces Winner</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdxljz8.html">《ArcGIS Engine&plus;C&num;实例开发教程》第八讲 属性数据表的查询显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdxln38.html">Android include的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xkjdz9.html">plsql 高效原则</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn10d5g8.html">exynos4412电路OrCAD问题</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
